<?php

// Time formatting

function ITtoDWT($time) { //convert hh:mm to time for the dw column
	global $dateUSorEU;
	return ($dateUSorEU) ? substr($time,0,5) : date("g:iA", strtotime($time));
}

function ITtoDT($time,$format = -1) { //convert hh:mm(:ss) to display time
	global $time24;
	if (!$time) { return ""; }
	if ($format < 0) { $format = $time24; }
	return ($format) ? substr($time,0,5) : ($time == '24:00' ? '12:00AM' : date("g:iA", strtotime($time)));
}

function DTtoIT($time,$format = -1) { //convert display time to ISO time hh:mm
	global $time24;
	$time = trim($time);
	if (!$time) { return ""; }
	if ($format < 0) { $format = $time24; }
	if ($format) {
		if (!preg_match("%^(0{0,1}[0-9]|1[0-9]|2[0-4])[:.][0-5][0-9]([:.][0-5][0-9]){0,1}$%",$time)) {
			return false;
		}
	} else {
		if (!preg_match("%^(0{0,1}[0-9]|1[0-2])[:.][0-5][0-9]\s*(a|A|p|P)(m|M)$%",$time)) {
			return false;
		}
	}
	$tStamp = strtotime($time);
	return ($tStamp < 1) ? false : date("H:i", $tStamp);
}


// Date formatting

function IDtoDD($date,$format = -1) { //convert yyyy mm dd to display date
	global $dateFormat, $dateSep;
	if (!$date) { return ""; }
	if ($format < 0) { $format = $dateFormat; }
	switch ($format) {
	case 1: //dd mm yyyy
		return substr($date,8,2).$dateSep.substr($date,5,2).$dateSep.substr($date,0,4);
	case 2: //mm dd yyyy
		return substr($date,5,2).$dateSep.substr($date,8,2).$dateSep.substr($date,0,4);
	case 3: //yyyy mm dd
		return substr($date,0,4).$dateSep.substr($date,5,2).$dateSep.substr($date,8,2);
	}
}

function DDtoID($date,$format = -1) { //validate display date and convert to ISO date yyyy-mm-dd
	global $dateFormat;
	$date = trim($date);
	if (!$date) { return ""; }
	if ($format < 0) { $format = $dateFormat; }
	switch ($format) {
	case 1: //dd mm yyyy
		if (!preg_match("%^(0{0,1}[1-9]|[1-2][0-9]|3[0-1])[\/\.-](0{0,1}[1-9]|1[0-2])[\/\.-](20[0-9]{2})$%",$date,$hits)) { return false; }
		if (!checkdate(intval($hits[2]),intval($hits[1]),intval($hits[3]))) { return false; }
		return $hits[3]."-".str_pad($hits[2], 2, "0", STR_PAD_LEFT)."-".str_pad($hits[1], 2, "0", STR_PAD_LEFT);
	case 2: //mm dd yyyy
		if (!preg_match("%^(0{0,1}[1-9]|1[0-2])[\/\.-](0{0,1}[1-9]|[1-2][0-9]|3[0-1])[\/\.-](20[0-9]{2})$%",$date,$hits)) { return false; }
		if (!checkdate(intval($hits[1]),intval($hits[2]),intval($hits[3]))) { return false; }
		return $hits[3]."-".str_pad($hits[1], 2, "0", STR_PAD_LEFT)."-".str_pad($hits[2], 2, "0", STR_PAD_LEFT);
	case 3: //yyyy mm dd
		if (!preg_match("%^(20[0-9]{2})[\/\.-](0{0,1}[1-9]|1[0-2])[\/\.-](0{0,1}[1-9]|[1-2][0-9]|3[0-1])$%",$date,$hits)) { return false; }
		if (!checkdate(intval($hits[2]),intval($hits[3]),intval($hits[1]))) { return false; }
		return $hits[1]."-".str_pad($hits[2], 2, "0", STR_PAD_LEFT)."-".str_pad($hits[3], 2, "0", STR_PAD_LEFT);
	}
}

/* Note: if your ISP didn't install PHP multi-byte support, comment out lines 79 and 94 and use lines 80 and 95 instead */

function makeD($date,$format,$m3) { //make long date
	global $dateUSorEU, $months, $wkDays;
	$d = ltrim(substr($date, 8, 2),"0");
	$mN = ltrim(substr($date, 5, 2),"0");
	$m = $m3 ? mb_substr($months[$mN - 1],0,3,"UTF-8") : $months[$mN - 1]; //see note above
//	$m = $m3 ? substr($months[$mN - 1],0,3) : $months[$mN - 1]; //see note above
	$y = substr($date, 0, 4);
	switch ($format) {
	case 1: //Dec... 9 / 9 dec...
		return ($dateUSorEU) ? $d.' '.$m : $m.' '.$d;
	case 2: //Dec... 9, 2010 / 9 dec... 2010
		return ($dateUSorEU) ? $d.' '.$m.' '.$y : $m.' '.$d.', '.$y;
	case 3: //Dec... 2010 / dec... 2010
		return ($dateUSorEU) ? $m.' '.$y : $m.' '.$y;
	case 4: //Monday, Dec... 9 / monday 9 dec...
		$wd = $wkDays[date("N", mktime(0,0,0,substr($date,5,2),substr($date,8,2),substr($date,0,4)))];
		return ($dateUSorEU) ? $wd.' '.$d.' '.$m : $wd.', '.$m.' '.$d;
	case 5: //Mon, Dec 9 / mon 9 dec
		$wd = $wkDays[date("N", mktime(0,0,0,substr($date,5,2),substr($date,8,2),substr($date,0,4)))];
		return ($dateUSorEU) ? mb_substr($wd,0,3,"UTF-8").' '.$d.' '.mb_substr($m,0,3,"UTF-8") : mb_substr($wd,0,3,"UTF-8").', '.mb_substr($m,0,3,"UTF-8").' '.$d; //see note above
//		return ($dateUSorEU) ? substr($wd,0,3).' '.$d.' '.substr($m,0,3) : substr($wd,0,3).', '.substr($m,0,3).' '.$d; //see note above
	case 6: //Monday, Dec... 9, 2010 / monday 9 dec... 2010
		$wd = $wkDays[date("N", mktime(0,0,0,substr($date,5,2),substr($date,8,2),substr($date,0,4)))];
		return ($dateUSorEU) ? $wd.' '.$d.' '.$m.' '.$y : $wd.', '.$m.' '.$d.', '.$y;
	}
}


// Database querying

function dbquery($q) {
	global $dbPrefix;
	$q = str_replace ("[db]", $dbPrefix, $q) ; //add database prefix
	$result = mysql_query($q);
	if ($result === false) {
		file_put_contents("logs/mysql.log", date(DATE_ATOM)."\nScript name: ".$_SERVER['PHP_SELF']."\nMySQL error: ".mysql_error()."\nQuery string: $q\n\n" , FILE_APPEND); exit;
	}
	return $result;
}

?>