<?php
/*
= check calendar for events to be notified to the originator =

 Copyright 2010 LuxSoft - Luxembourg - www.LuxSoft.eu

---------------------------------------------------------------------
| This script depends on and is executed via the file lcalcron.php. |
| See lcalcron.php header for details.                              |
---------------------------------------------------------------------

This file is part of the LuxCal Web Calendar.

The LuxCal Web Calendar is free software: you can redistribute it and/or modify it under 
the terms of the GNU General Public License as published by the Free Software Foundation, 
either version 3 of the License, or (at your option) any later version.

The LuxCal Web Calendar is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with the LuxCal 
Web Calendar. If not, see <http://www.gnu.org/licenses/>.

------------ THIS SCRIPT USES THE FOLLOWING CONFIG.PHP PARAMETERS -------
| $calendarEmail : Email source ("from") for notification messages      |
| $calendarTitle : The calendar title is part of the notification email |
| The database credentials : to connect to the calendar database        |
-------------------------------------------------------------------------
*/

$sumToAdmin = true; //send summary of sent notifications to admin
$emlStyle = "background:#FFFFDD; color:#000099; font:12px arial, sans-serif;"; //email body style definition

//
// Send email notification
//
function notify($eventId, $sDate, $eDate, $sTime, $eTime) {
global $emlStyle, $count, $calendarEmail, $mailSent, $showOwner, $ax, $calendarTitle, $daysDue, $todayD00;

	$q =
	"SELECT
		e.title,
		e.venue,
		e.description,
		e.not_mail,
		c.name,
		c.color,
		c.background,
		u.user_name
	FROM [db]events e
		INNER JOIN [db]categories c ON c.category_id = e.category_id
		INNER JOIN [db]users u ON u.user_id = e.user_id
	WHERE
		e.event_id = $eventId";
	$event = dbquery($q); //retrieve event data
	if (!$event) { exit; }
	if (mysql_num_rows($event) == 0) { exit; }
	$row = mysql_fetch_assoc($event);
	// compose email message
	$eventT = ($eTime[0] < "9") ? (($sTime == "00:00" and $eTime == "23:59") ? $ax["not_all_day"] : ITtoDT($sTime)." - ".ITtoDT($eTime)) : ITtoDT($sTime);
	$subject = $calendarTitle." - ".$ax["not_due_in"]." ".$daysDue." ".$ax["not_days"].": ".stripslashes($row["title"]);
	$style = ($row["color"] or $row["background"]) ? " style=\"color: ".$row["color"]."; background: ".$row["background"].";\"" : "";
	$sender = ($showOwner) ? "<tr><td>".$ax['not_sender'].":</td><td>".stripslashes($row['user_name'])."</td></tr>" : "";
	$message = "
<html>
<head>\n<title>".$calendarTitle." ".$ax["not_mailer"]."</title>
<style type='text/css'>
body, p, table {".$emlStyle."}
td {vertical-align:top;}
</style>
</head>
<body>
<p>".$calendarTitle." ".$ax["not_mailer"]." ".IDtoDD($todayD00)."</p>
<p>".$ax["not_event_due_in"]." ".$daysDue." ".$ax["not_days"].":</p>
<table>
	<tr><td>".$ax['not_title'].":</td><td><b><span".$style.">".stripslashes($row["title"])."</span></b></td></tr>
	<tr><td>".$ax['not_category'].":</td><td>".stripslashes($row["name"])."</td></tr>
	".$sender."
	<tr><td>".$ax['not_date_time'].":</td><td>".IDtoDD($sDate)." @ ".$eventT."</td></tr>
	<tr><td>".$ax['not_venue'].":</td><td>".(($row["venue"]) ? stripslashes($row["venue"]) : "- -")."</td></tr>
	<tr><td>".$ax['not_description'].":</td><td>".(($row["description"]) ? stripslashes($row["description"]) : "- -")."</td></tr>
</table>
</body>
</html>
";
	$headers = 'MIME-Version: 1.0'."\r\n".'Content-type: text/html; charset=utf-8'."\r\n".'From: '.$calendarEmail;
	// send emails
	if ($row["not_mail"]) { // email address(es) to notify
		$emlList = explode(";", $row["not_mail"]);
		foreach ($emlList as $emlAddress) {
			if (mail($emlAddress, $subject, $message, $headers)) {
				$mailSent .= ++$count.". To: ".str_replace("@","[at]",$emlAddress)." - Subject: ".$subject."\n";
			}
		}
	}
}

//
// Compute next event start date for recurring event
//
function nextRdate($curD, $rT, $rI, $rP, $i) {
	if($rT == 1) { // repeat xth day, week, month, year
		switch ($rP) { // period
		case 1: // day
			$nxtD = date("Y-m-d", mktime(12, 0, 0, substr($curD,5,2), substr($curD,8,2)+$rI, substr($curD,0,4)));
       break;
		case 2: // week
			$nxtD = date("Y-m-d", (mktime(12, 0, 0, substr($curD,5,2), substr($curD,8,2), substr($curD,0,4)) + ($rI * 604800)));
       break;
		case 3: // month
			$nxtD = date("Y-m-d", mktime(12, 0, 0, substr($curD,5,2)+$rI, substr($curD,8,2), substr($curD,0,4)));
       break;
		case 4: // year
			$nxtD = date("Y-m-d", mktime(12, 0, 0, substr($curD,5,2), substr($curD,8,2), substr($curD,0,4)+$rI));
		}
	} else { // repeat on the xth <dayname> of the month
		$day1Ts = mktime(12, 0, 0, substr($curD,5,2)+$i, 1, substr($curD,0,4));
		$dowDif = $rP - date('N',$day1Ts); //day of week difference
		$offset = $dowDif + 7 * $rI;
		if ($dowDif >= 0) { $offset -= 7; }
		if ($offset > date('t',$day1Ts)) { $offset -= 7; }
		$nxtD = date("Y-m-d", $day1Ts + (86400 * $offset));
	}
	return $nxtD;
}

// initialize
$todayT = mktime(12,0,0); //12:00
$todayD00 = date("Y-m-d", $todayT); //today
$todayD30 = date("Y-m-d", $todayT + 2592000); //today + 30 days
$count = 0;
$mailSent = "";

//
//process non-recurring events (select events due in next 30 days with "notify" set)
//
$q =
 "SELECT
		event_id,
		s_date,
		e_date,
		s_time,
		e_time,
		notify
	FROM [db]dates
	WHERE
		status >= 0
		AND notify > 0
		AND r_type = 0
		AND s_date >= '$todayD00'
		AND s_date <= '$todayD30'";
$dates = dbquery($q);
if (!$dates) { exit; }
while ($rowD = mysql_fetch_assoc($dates)) { // date fields
	$daysDue = round((mktime(12,0,0,substr($rowD["s_date"],5,2),substr($rowD["s_date"],8,2),substr($rowD["s_date"],0,4)) - $todayT) / 86400);
	if ($daysDue == $rowD["notify"] or $rowD["s_date"] == $todayD00) { // notify
		notify($rowD["event_id"], $rowD["s_date"], $rowD["e_date"], substr($rowD["s_time"],0,5), substr($rowD["e_time"],0,5)); // send email for event_id
	}
}
//
//process recurring events - select events that could be due in next 30 days with "notify" set
//
$q =
	"SELECT
		event_id,
		s_date,
		e_date,
		s_time,
		e_time,
		notify,
		r_type,
		r_interval,
		r_period,
		r_until
	FROM [db]dates
	WHERE
		status >= 0
		AND notify > 0
		AND r_type > 0
		AND r_until >= '$todayD00'
		AND s_date <= '$todayD30'";
$dates = dbquery($q);
if (!$dates) { exit; }
while ($rowD = mysql_fetch_assoc($dates)) { // date fields
	$eStart = ($rowD[s_date] < $todayD00 and !($rowD[r_type] == 1 and $rowD[r_period] == 2)) ? strval(intval(substr($todayD00,0,4))-1).substr($rowD[s_date],4) : $rowD[s_date]; // year insignificant
	if ($rowD[r_type] == 2) {
		$nxtD = nextRdate($eStart,$rowD[r_type],$rowD[r_interval],$rowD[r_period],0); // goto 1st occurence of xth <dayname> in current month
		$eStart = ($nxtD < $eStart) ? nextRdate($eStart,$rowD[r_type],$rowD[r_interval],$rowD[r_period],1) : $nxtD;
	}
	while ($eStart <= min($todayD30, $rowD[r_until]) and $rowD[r_until] >= $todayD00) {
		if ($eStart >= $todayD00) {
			$daysDue = round((mktime(12,0,0,substr($eStart,5,2),substr($eStart,8,2),substr($eStart,0,4)) - $todayT) / 86400);
			if ($daysDue == $rowD["notify"] or $eStart == $todayD00) { // notify
				notify($rowD["event_id"], $eStart, $rowD["e_date"], substr($rowD["s_time"],0,5), substr($rowD["e_time"],0,5)); // send email for event_id
			}
			break;
		}
		$eStart = nextRdate($eStart,$rowD[r_type],$rowD[r_interval],$rowD[r_period],1);
	}
}

if ($sumToAdmin) { //send summary to admin
	echo "Notifications ".$calendarTitle." ~ ".IDtoDD($todayD00)." ".date("H:i", mktime())."\n\n";
	echo (strlen($mailSent) > 0) ? "Notifications sent: \n".$mailSent : "No notification dates due.\n";
}
?>
