<?php
/*
= Send email notification of calendar changes (added / edited / deleted events) =

 Copyright 2010 LuxSoft - Luxembourg - www.LuxSoft.eu

-------------------------------------------------------------------
 This script depends on and is executed via the file lcalcron.php.
 See lcalcron.php header for details.
-------------------------------------------------------------------

This file is part of the LuxCal Web Calendar.

The LuxCal Web Calendar is free software: you can redistribute it and/or modify it under 
the terms of the GNU General Public License as published by the Free Software Foundation, 
either version 3 of the License, or (at your option) any later version.

The LuxCal Web Calendar is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with the LuxCal 
Web Calendar. If not, see <http://www.gnu.org/licenses/>.

------- THIS SCRIPT USES THE FOLLOWING CONFIG.PHP PARAMETERS -------
$chgEmailList : list with email destinations separated by semicolons
$chgNofDays : number of days to look back for calendar changes
--------------------------------------------------------------------
*/

$emlStyle = "background:#FFFFDD; color:#000099; font:12px arial, sans-serif;"; //email body style definition

function grabChanges($sDate) { //query db for changes since $sDate
	global $evtList;
	$q =
	"SELECT
		d.s_date, #0
		d.e_date, #1
		DATE_FORMAT(d.s_time,'%H:%i'), #2
		DATE_FORMAT(d.e_time,'%H:%i'), #3
		d.r_type, #4
		d.r_interval, #5
		d.r_period, #6
		d.r_until, #7
		d.notify, #8
		d.a_date, #9
		d.m_date, #10
		d.status, #11
		e.event_id, #12
		e.title, #13
		e.category_id, #14
		e.venue, #15
		e.user_id, #16
		e.description, #17
		e.private, #18
		c.sequence, #19
		c.color, #20
		c.background, #21
		u.user_name #22
	FROM [db]events e
		INNER JOIN [db]dates d ON d.event_id = e.event_id
		INNER JOIN [db]categories c ON c.category_id = e.category_id
		INNER JOIN [db]users u ON u.user_id = e.user_id
	WHERE
		d.m_date != '9999-00-00' AND d.m_date >= '$sDate'";
	$query = dbquery($q);

	//process events
	while ($row = mysql_fetch_row($query)) {
		$event['sda'] = $row[0];
		$event['eda'] = ($row[1][0] != '9') ? $row[1] : "";
		if (($row[2] == "00:00") and ($row[3] == "23:59")) {
			$event['sti'] = $event['eti'] = ""; //all day: start/end time = ""
		} else {
			$event['sti'] = $row[2];
			$event['eti'] = ($row[3][0] != "9") ? $row[3] : ""; // no end time = ""
		}
		$event['r_t'] = $row[4];
		$event['r_i'] = $row[5];
		$event['r_p'] = $row[6];
		$event['r_u'] = ($row[7][0] != '9') ? $row[7] : "";
		$event['not'] = $row[8];
		$event['ada'] = ($row[9][0] != '9') ? $row[9] : "";
		$event['mda'] = $row[10];
		$event['sts'] = $row[11];
		$event['eid'] = $row[12];
		$event['tit'] = stripslashes(strip_tags($row[13]));
		$event['cat'] = $row[14];
		$event['ven'] = stripslashes($row[15]);
		$event['uid'] = $row[16];
		$event['des'] = stripslashes($row[17]);
		$event['pri'] = $row[18];
		$event['seq'] = str_pad($row[19],2,"0",STR_PAD_LEFT);
		$event['col'] = $row[20];
		$event['bco'] = $row[21];
		$event['una'] = $row[22];
		$evtList[$event['mda']][] = $event;
	}
}

function sortEvt($a, $b) { return strcmp(strval($a['sts']+1).$a['sda'].$a['sti'], strval($b['sts']+1).$b['sda'].$b['sti']); }

function makeGrid($date) {
	global $evtList, $emlStyle, $showOwner, $xx;

	if ($evtList[$date]) {
		usort($evtList[$date], 'sortEvt');
		$changeList = "<h5>".$xx['chg_changed_on']." ".makeD($date,6,false)."</h5>\n";
		foreach ($evtList[$date] as $evt) {
			switch ($evt["r_t"]) { //make repeat text
				case 0: $repeat = ""; break;
				case 1: $repeat = $xx["evt_repeat"].' '.$xx["evt_interval1_".$evt["r_i"]].' '.$xx["evt_period1_".$evt["r_p"]]; break;
				case 2: $repeat = $xx["evt_repeat_on"].' '.$xx["evt_interval2_".$evt["r_i"]].' '.$wkDays[$evt["r_p"]].' '.$xx["evt_of_the_month"];
			}
			if ($evt["r_t"] > 0 and $evt["r_u"]) {
				$repeat .= ' '.$xx["evt_until"].' '.IDtoDD($evt["r_u"]);
			}
			$changeList .= "<table><tr><td width=\"100px\">";
			$changeList .= ($evt['sts'] < 0) ? $xx["chg_deleted"] : ($evt['mda'] > $evt['ada'] ? $xx["chg_edited"] : $xx["chg_added"]);
			$changeList .= "&nbsp;&nbsp;&nbsp;&nbsp;</td><td>";
			$changeList .= "<span".(($evt['col'] or $evt['bco']) ? " style=\"color: ".$evt['col']."; background: ".$evt['bco'].";\"><b>" : "><b>").$evt['tit']."</b></span><br />\n";
			$changeList .= IDtoDD($evt['sda']);
			if ($evt['sti']) $changeList .= " @ ".ITtoDT($evt['sti']);
			if ($evt['eda'] or $evt['eti']) $changeList .= " -";
			if ($evt['eda']) $changeList .= " ".IDtoDD($evt['eda']);
			if ($evt['eda'] and $evt['eti']) $changeList .= " @";
			if ($evt['eti']) $changeList .= " ".ITtoDT($evt['eti']);
			$changeList .= (($evt['sti'] == "" and $evt['eti'] == "") ? " ".$xx["vws_all_day"] : "").$repeat."<br />";
			if ($evt['ven']) { $changeList .= $xx["vws_venue"].": ".$evt['ven']."<br />\n"; }
			if ($evt['des']) { $changeList .= $evt['des']."<br />\n"; }
			if ($evt['not']) { $changeList .= "# ".$xx["chg_notify"].": ".$evt['not']." ".$xx["chg_days"]." #<br />\n"; }
			if ($showOwner) { $changeList .= $xx["vws_owner"].": ".$evt['una']."<br />\n"; }
			$changeList .= "</td></tr></table><br />\n";
		}
	}
	return $changeList;
}

function sendEmail($msgText) { //send email(s) with calendar changes
	global $chgEmailList, $period, $xx, $calendarTitle, $calendarEmail;

	$headers = 'MIME-Version: 1.0'."\r\n".'Content-type: text/html; charset=utf-8'."\r\n".'From: '.$calendarEmail;
	$subject = $calendarTitle." - ".$xx["chg_changes"].": ".$period;
	if ($chgEmailList) { // email address(es) to notify
		$emlList = explode(";", $chgEmailList);
		foreach ($emlList as $emlAddress) {
			mail(trim($emlAddress), $subject, $msgText, $headers);
		}
	}
}


// main program

$evtList = array();

//init
$toDay = mktime(0, 0, 0); // Unix time of today
$fromD = date("Y-m-d", $toDay - $chgNofDays * 86400); // start date
$emlText =
"<html>
<head>\n<title>".$calendarTitle." mailer</title>
<style type='text/css'>
body, p, table {".$emlStyle."}
h5 {font-size:13px;}
td {vertical-align:top;}
</style>
</head>
<body>
";

grabChanges($fromD); // query db for changes

$period = ($fromD != date('Y-m-d')) ? makeD($fromD,2,false)." - ".makeD(date('Y-m-d'),2,false) : makeD(date('Y-m-d'),2,false);

if ($evtList) {
	krsort($evtList);
	while (list($k) = each($evtList)) {
		$emlText .= makeGrid($k);
	}
} else {
	$emlText .= $xx["chg_no_changes"];
}
	$emlText .=
"</body>
</html>
";
sendEmail($emlText);
?>
