<?php
/*
= LuxCal event calendar index =

 Copyright 2010 LuxSoft - Luxembourg - www.LuxSoft.eu

This file is part of the LuxCal Web Calendar.

The LuxCal Web Calendar is free software: you can redistribute it and/or modify it under 
the terms of the GNU General Public License as published by the Free Software Foundation, 
either version 3 of the License, or (at your option) any later version.

The LuxCal Web Calendar is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with the LuxCal 
Web Calendar. If not, see <http://www.gnu.org/licenses/>.
*/

if (!file_exists("config.php")) header("Location: install.php");
require 'config.php';
require 'common/toolbox.php';

error_reporting(E_ALL ^ E_NOTICE); //errors, no notices
//error_reporting(E_ALL); //errors and notices - test line

//Current LuxCal version
define("LCV","2.3.2");

//set time zone
date_default_timezone_set($timeZone);

//proxies: don't cache
header("Cache-control: private");

//start session
session_set_cookie_params(2500000); //expire in 1 month
session_start();
if (!isset($_SESSION['lastTime']) or $_SESSION['lastTime'] + 3600 < time()) {  //reset current date and cat
	unset($_SESSION['cD'], $_SESSION['cC']);
}
$_SESSION['lastTime'] = time();
if (empty($_SESSION['uid'])) { $_SESSION['uid'] = 1; }

//establish database connection
$link = mysql_connect($hn, $un, $pw) or die ("Could not connect to database, check database credentials in config.php");
if (!mysql_select_db($db,$link)) die ("Could not select database $db");

//run upgrade if config.php not current
if (!defined('LCC') or LCC < LCV) { require 'upgrade'.str_replace('.','',LCV).'.php'; }

//get permissions
$query = dbquery("SELECT user_name, sedit, privs FROM [db]users WHERE user_id = {$_SESSION['uid']} LIMIT 1");
if ($row = mysql_fetch_assoc($query)) {
	$uname = $row["user_name"];
	$privs = $row["privs"];
	$sedit = ($row["sedit"]) ? 1 : 0;
} else { $sedit = $privs = 0; }

//set language
if (isset($_REQUEST["cL"])) { $_SESSION['cL'] = $_REQUEST["cL"]; }
elseif (empty($_SESSION['cL'])) { $_SESSION['cL'] = $language; }
if (!file_exists('lang/ui-'.strtolower($_SESSION['cL']).'.php')) { $_SESSION['cL'] = "English"; }
require 'lang/ui-'.strtolower($_SESSION['cL']).'.php';

if ($_SESSION['uid'] == 1) { $uname = $xx["idx_public_name"]; }

//page definitions
$pages = array (
	 "1" => array ("views/year.php", "", "L", ""),
	 "2" => array ("views/month.php", "", "L", ""),
	 "3" => array ("views/week.php", "", "L", ""),
	 "4" => array ("views/day.php", "", "L", ""),
	 "5" => array ("views/upcoming.php", "", "L", $xx["title_upcoming"]),
	 "6" => array ("views/changes.php", "", "L", $xx["title_changes"]),

	"10" => array ("pages/event.php", '$_REQUEST["mode"] = "add";', "S", $xx["title_event"]),
	"11" => array ("pages/event.php", '$_REQUEST["mode"] = "edit";', "S", $xx["title_event"]),

	"20" => array ("pages/login.php", "", "L", ""),
	"21" => array ("lang/ug-".strtolower($_SESSION['cL']).".php", "", "S", $xx["title_user_guide"]),

	"90" => array ("pages/settings.php", "", "L", $xx["title_settings"]),
	"91" => array ("pages/categories.php", "", "L", $xx["title_edit_cats"]),
	"92" => array ("pages/users.php", "", "L", $xx["title_edit_users"]),
	"93" => array ("pages/database.php", "", "L", $xx["title_manage_db"]),
	"94" => array ("pages/importICS.php", "", "L", $xx["title_ics_import"]),
	"95" => array ("pages/exportICS.php", "", "L", $xx["title_ics_export"]),
	"96" => array ("pages/importCSV.php", "", "L", $xx["title_csv_import"])
);

//set header (nav bar) display
if (isset($_REQUEST['hdr'])) { $_SESSION['hdr'] = $_REQUEST['hdr']; }
elseif (!isset($_SESSION['hdr'])) { $_SESSION['hdr'] = 1; }

//set current page
if (isset($_REQUEST['cP'])) { $_SESSION['cP'] = $_REQUEST['cP']; }
if (empty($_SESSION['cP'])) { $_SESSION['cP'] = $defaultView; }
elseif (!array_key_exists($_SESSION['cP'], $pages) or $pages[$_SESSION['cP']][2] == "S") { $_SESSION['cP'] = $defaultView; }
$cP = (isset($_REQUEST['xP'])) ? $_REQUEST['xP'] : $_SESSION['cP']; //$xP: extra page in separate window

//set current date
if (isset($_REQUEST['newD'])) { $_SESSION['cD'] = DDtoID($_REQUEST['newD']); }
elseif (isset($_REQUEST['cD'])) { $_SESSION['cD'] = $_REQUEST['cD']; }
elseif (empty($_SESSION['cD'])) { $_SESSION['cD'] = date("Y-m-d"); }

//set category filter
if (isset($_REQUEST['cC'])) { $_SESSION['cC'] = $_REQUEST['cC']; }
elseif (!isset($_SESSION['cC'])) { $_SESSION['cC'] = 0; }

//if no access, login required
if (!$privs) {
	$cP = 20; //log in
	$msg = $xx["idx_log_in"];
}

eval($pages[$cP][1]);
$pageTitle = $pages[$cP][3];

require ($pages[$cP][2] == "S") ? 'canvas/header_s.php' : (($_SESSION['hdr'] == 0) ? 'canvas/header_xs.php' : 'canvas/header.php');
require $pages[$cP][0];
require 'canvas/footer.php';
?>
