<?php
/*
= LuxCal event calendar cronjobs =

 Copyright 2010 LuxSoft - Luxembourg - www.LuxSoft.eu

This file should be started via a cronjob once a day at 2am local time
======================================================================

It will start the following scripts:
1. notify.php: 
	Generate email notifications for events for which the user has asked a 
	notification a certain number of days before the due date of the event.

2. sendchg.php:
	If specified on the admin Settings page, send an email with a summary of 
	calendar changes to the email address list specified on the Settings page.
	If setting $chgNofDays = 0, NO email with calendar changes will be sent.

3. userchk.php:
	If specified in the admin Settings, delete 'inactive' user accounts.
	If setting $maxNoLogin = 0, NO user account will be deleted.

------------- CRON JOB SETTINGS (UNIX NOTATION) -------------
Minute Hour Day Month Weekday
   0     2   *    *      *
Note: 
If the calendar server and the calendar user are in different 
timezones, the Hour should correspond to 3AM user time.
-------------------------------------------------------------

------------ THIS SCRIPT USES THE FOLLOWING CONFIG.PHP PARAMETERS ------------
$timeZone : To get the current time right
The database credentials : to connect to the calendar database
$chgNofDays : Number of days to look back for changes
$maxNoLogin : Number of 'no login' days, after which a user account is deleted
------------------------------------------------------------------------------
*/

//load calendar settings, toolbox and language files
require 'config.php';
require 'common/toolbox.php';
require 'lang/ui-'.strtolower($language).'.php';
require 'lang/ai-'.strtolower($language).'.php';

//set timezone
date_default_timezone_set($timeZone);

//connect to database
$link = mysql_connect ($hn, $un, $pw) or die ("Could not connect to LuxCal database");
mysql_select_db($db,$link);

// 1
include 'cronjobs/notify.php';

// 2
if ($chgNofDays > 0) {
	include 'cronjobs/sendchg.php';
}

// 3
if ($maxNoLogin > 0) {
	include 'cronjobs/userchk.php';
}

mysql_close($link); //close database
?>