<?php
/*
= LuxCal database management page =

 Copyright 2010 LuxSoft - Luxembourg - www.LuxSoft.eu

This file is part of the LuxCal Web Calendar.

The LuxCal Web Calendar is free software: you can redistribute it and/or modify it under 
the terms of the GNU General Public License as published by the Free Software Foundation, 
either version 3 of the License, or (at your option) any later version.

The LuxCal Web Calendar is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with the LuxCal 
Web Calendar. If not, see <http://www.gnu.org/licenses/>.
*/

$adminLang = (file_exists('lang/ai-'.strtolower($_SESSION['cL']).'.php')) ? $_SESSION['cL'] : "English";
require 'lang/ai-'.strtolower($adminLang).'.php';

$msg = '';
$repair = $compact = $backup = 0;
if (!empty($_POST["repair"])) { $repair = 1; }
if (!empty($_POST["compact"])) { $compact = 1; }
if (!empty($_POST["backup"])) { $backup = 1; }
$mdb_exe = (isset($_POST["mdb_exe"])) ? 1 : 0;

function mdbForm() {
	global $ax, $compact, $repair, $backup, $msg;
	echo '<div class="sideBar floatR">'.$ax['xpl_manage_db']."</div>\n";
	echo '<form action="index.php" method="post">'."\n";
	echo '<table class="fieldBox">'."\n";
	echo '<tr><td class="legend">&nbsp;'.$ax['mdb_dbm_functions'].'&nbsp;</td></tr><br />'."\n";
	echo "<tr><td>&nbsp;</td></tr>\n";
	echo '<tr><td><input type="checkbox" name="repair" value="yes"'.(($repair > 0) ? ' checked="checked" /> ' : ' > ').$ax['mdb_repair']."</td></tr>\n";
	echo "<tr><td>&nbsp;</td></tr>\n";
	echo '<tr><td><input type="checkbox" name="compact" value="yes"'.(($compact > 0) ? ' checked="checked" /> ' : ' > ').$ax['mdb_compact']."</td></tr>\n";
	echo "<tr><td>&nbsp;</td></tr>\n";
	echo '<tr><td><input type="checkbox" name="backup" value="yes"'.(($backup > 0) ? ' checked="checked" /> ' : ' > ').$ax['mdb_backup']."</tr>\n";
	echo "</table>\n";
	echo '<input class="button" type="submit" name="mdb_exe" value="'.$ax['mdb_start'].'" />'."\n";
	echo "</form>\n";
}

/* Check and repair db */
function repairDb() {
	global $ax;
	echo '<table class="fieldBoxFix">'."\n";
	echo '<tr><td class="legend">&nbsp;'.$ax['mdb_repair'].'&nbsp;</td></tr>'."\n";
	//delete orphans from events table
	echo '<tr><td>'.$ax['mdb_process_table']." 'events' - ";
	$query = dbquery("DELETE e FROM [db]events e LEFT JOIN [db]dates d ON e.event_id = d.event_id WHERE d.event_id IS NULL");
	echo $ax['mdb_repair_done'].". ".$ax['mdb_repair_errors'].' '.mysql_affected_rows()."</td></tr>\n";
	//delete orphans from dates table
	echo '<tr><td>'.$ax['mdb_process_table']." 'dates' - ";
	$query = dbquery("DELETE d FROM [db]dates d LEFT JOIN [db]events e ON d.event_id = e.event_id WHERE e.event_id IS NULL");
	echo $ax['mdb_repair_done'].". ".$ax['mdb_repair_errors'].' '.mysql_affected_rows()."</td></tr>\n";
	echo "</table>\n";
}

/* Compact db tables */
function compactTables() {
	global $ax;
	echo '<table class="fieldBoxFix">'."\n";
	echo '<tr><td class="legend">&nbsp;'.$ax['mdb_compact'].'&nbsp;</td></tr>'."\n";
	$deleteD = date('Y-m-d', time() - 86400*30); // remove if deleted more than 30 days ago
	//remove deleted events from db
	$query = dbquery("DELETE d, e FROM [db]events e INNER JOIN [db]dates d ON d.event_id = e.event_id WHERE d.status = -1 and d.m_date <= '".$deleteD."'");
	echo '<tr><td>'.$ax['mdb_purge_done']."</td></tr>\n";
	$rSet = dbquery('SHOW TABLES');
	if (!$rSet) {
		echo '<tr><td>'.$ax['mdb_noshow_tables']."</td></tr>\n";
	} else {
		while ($table = mysql_fetch_row($rSet)) {
			echo '<tr><td>'.$ax['mdb_compact_table'].' \''.$table[0].'\' - ';
			$query = dbquery('OPTIMIZE TABLE '.$table[0]);
			echo (!$query ? $ax['mdb_compact_error'] : $ax['mdb_compact_done'])."</td></tr>\n";
		}
	}
	echo "</table>\n";
}

/* Backup db tables*/
function backupTables() {
	global $ax, $msg;
	//get table names
	$tableSet = dbquery('SHOW TABLES');
	echo '<table class="fieldBoxFix">'."\n";
	echo '<tr><td class="legend">&nbsp;'.$ax['mdb_backup'].'&nbsp;</td></tr>'."\n";
	if (!$tableSet) {
		echo '<tr><td>'.$ax['mdb_noshow_tables']."</td></tr>\n";
	} else {
		//backup tables
		$sqlFile = '';
		while ($table = mysql_fetch_row($tableSet)) {
			echo '<tr><td>'.$ax['mdb_backup_table'].' \''.$table[0].'\' - ';
			$rSet = dbquery('SELECT * FROM '.$table[0]);
			$nrFields = mysql_num_fields($rSet);
			$sqlFile .= 'DROP TABLE '.$table[0].';';
			$createTableCode = mysql_fetch_row(dbquery('SHOW CREATE TABLE '.$table[0]));
			$sqlFile .= "\n\n".$createTableCode[1].";\n\n";
			for ($i = 0; $i < $nrFields; $i++) {
				while($row = mysql_fetch_row($rSet)) {
					$sqlFile .= 'INSERT INTO '.$table[0].' VALUES(';
					for($j=0; $j<$nrFields; $j++) {
						$row[$j] = ereg_replace("\n","\\n",$row[$j]);
						if (isset($row[$j])) { $sqlFile .= '"'.addslashes($row[$j]).'"' ; } else { $sqlFile .= '""'; }
						if ($j < ($nrFields-1)) { $sqlFile .= ','; } 
					}
					$sqlFile .= ");\n";
				}
			}
			$sqlFile .="\n";
			echo $ax['mdb_backup_done']."</td></tr>\n";
		}
		//save .sql backup file
		$fName = 'files/cal-backup-'.date('Ymd-His').'.sql';
		file_put_contents($fName, $sqlFile);
		echo "<tr><td>&nbsp;</td></tr>\n";
		echo '<tr><td>'.$ax['mdb_file_saved']."</td></tr>\n";
		echo '<tr><td>'.$ax['mdb_file_name'].' <strong>'.$fName."</strong></td></tr>\n";
	}
	echo "</table>\n";
}

// Control logic
if ($sedit) {
	if ($mdb_exe and (!$repair and !$compact and !$backup)) { $msg = $ax['mdb_no_function_checked'];	}
	echo "<br /><p class=".((isset($msg) and $msg) ? '"warningL">'.$msg : '"noWarningL">&nbsp;')."</p>\n";
	echo "<div class=\"container spaceLL\">\n";
	if (!$mdb_exe or (!$repair and !$compact and !$backup)) {
		mdbForm(); //manage db form
	} else {
		echo "<table><tr><td>\n";
		if ($repair) { repairDb(); }
		if ($compact) { compactTables(); }
		if ($backup) { backupTables(); }
		echo "</td></tr></table>\n";
		echo '<form action="index.php" method="post">'."\n";
		echo '<input type="hidden" name="repair" id="repair" value="'.$repair.'" />'."\n";
		echo '<input type="hidden" name="compact" id="compact" value="'.$compact.'" />'."\n";
		echo '<input type="hidden" name="backup" id="backup" value="'.$backup.'" />'."\n";
		echo '<input class="button" type="submit" name="back" value="'.$ax['mdb_back'].'" /></p>'."\n";
		echo "</form>\n";
	}
	echo "</div>\n";
} else {
	echo "<p class=\"warningL\">".$ax['cat_not_authorized']."</p>\n";
}
?>