<?php
/*
= iCal event file export script =

 Copyright 2010 LuxSoft - Luxembourg - www.LuxSoft.eu

This file is part of the LuxCal Web Calendar.

The LuxCal Web Calendar is free software: you can redistribute it and/or modify it under 
the terms of the GNU General Public License as published by the Free Software Foundation, 
either version 3 of the License, or (at your option) any later version.

The LuxCal Web Calendar is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with the LuxCal 
Web Calendar. If not, see <http://www.gnu.org/licenses/>.
*/

$adminLang = (file_exists('lang/ai-'.strtolower($_SESSION['cL']).'.php')) ? $_SESSION['cL'] : "English";
require 'lang/ai-'.strtolower($adminLang).'.php';

$fileDes = (isset($_POST["fileDes"])) ? stripslashes($_POST["fileDes"]) : ""; //file description
$catName = (isset($_POST["catName"])) ? $_POST["catName"] : ""; //category filter
$fromDda = (isset($_POST["fromDda"])) ? DDtoID($_POST["fromDda"]) : ""; //from event due date
$fromMda = (isset($_POST["fromMda"])) ? DDtoID($_POST["fromMda"]) : ""; //from event modified date
$tillDda = (isset($_POST["tillDda"])) ? DDtoID($_POST["tillDda"]) : ""; //untill event due date
$tillMda = (isset($_POST["tillMda"])) ? DDtoID($_POST["tillMda"]) : ""; //untill event modified date

$meta = array(); //iCal meta data
$calProps = array("PRODID","VERSION"); //iCal properties and components of interest


/* sub-functions */

function catMenu() {
	global $ax, $catName;
	$query = dbquery("SELECT name, color, background FROM [db]categories ORDER BY sequence");
	if ($query !== false) {
		echo '<option value="*">'.$ax["iex_all_cats"]."&nbsp;</option>\n";
		while ($row = mysql_fetch_assoc($query)) {
			$selected = ($catName == $row["name"]) ? " selected=\"selected\"" : "";
			$catStyle = ($row["color"] != "") ? " style=\"color: ".$row["color"]."; background: ".$row["background"].";\"" : "";
			echo '<option value="'.$row["name"].'"'.$catStyle.$selected.'>'.$row["name"]."</option>\n";
		}
	}
}


/* main functions */

function selectEvents() {
global $ax, $msg, $fileDes, $catName, $fromDda, $fromMda, $tillDda, $tillMda;
echo '<div class="sideBar floatR">'."\n";
echo $ax["xpl_export_ical"];
echo "</table>\n";
echo "</div>\n";
echo ($msg) ? "<br /><p class=\"warningL\">".$msg."</p>\n" : "<br /><p class=\"noWarningL\">&nbsp;</p>\n";
echo '<div class="container spaceLL">'."\n";
echo '<form action="index.php" method="post">'."\n";
echo '<table class="fieldBox">'."\n";
echo '<tr><td class="legend" colspan="2">&nbsp;'.$ax["iex_select_events"].'&nbsp;</td><tr>'."\n";
echo '<tr><td class="label">'.$ax["iex_ics_file_description"].':</td><td><input class="input" type="text" name="fileDes" value="'.$fileDes."\" maxlength='50' size='30' /></td></tr>\n";
echo '<tr><td class="label">'.$ax["iex_category"].':</td><td><select class="input" name="catName" >'."\n";
catMenu();
echo "</select></td><tr>\n";
echo '<tr><td class="label">'.$ax["iex_occuring_between"].':</td><td>';
echo '<input class="input" type="text" name="fromDda" id="fromDda" value="'.IDtoDD($fromDda)."\" size='8' />\n";
echo '<input class="button" type="button" title="'.$ax["iex_select_date"]."\" value=\"...\" onclick=\"dPicker('nill','fromDda')\" /> &#8211; ";
echo '<input class="input" type="text" name="tillDda" id="tillDda" value="'.IDtoDD($tillDda)."\" size='8' />\n";
echo '<input class="button" type="button" title="'.$ax["iex_select_date"]."\" value=\"...\" onclick=\"dPicker('nill','tillDda')\" /></td><tr>\n";
echo '<tr><td class="label">'.$ax["iex_changed_between"].':</td><td>';
echo '<input class="input" type="text" name="fromMda" id="fromMda" value="'.IDtoDD($fromMda)."\" size='8' />\n";
echo '<input class="button" type="button" title="'.$ax["iex_select_date"]."\" value=\"...\" onclick=\"dPicker('nill','fromMda')\" /> &#8211; \n";
echo '<input class="input" type="text" name="tillMda" id="tillMda" value="'.IDtoDD($tillMda)."\" size='8' />\n";
echo '<input class="button" type="button" title="'.$ax["iex_select_date"]."\" value=\"...\" onclick=\"dPicker('nill','tillMda')\" /></td><tr>\n";
echo "</table>\n";
echo '<input type="submit" name="create" value="'.$ax["iex_create_file"].'" />'."\n";
if (isset($_POST["create"]) and $msg == $ax["iex_file_created"]) {
	echo '&nbsp;&nbsp;&nbsp;&nbsp;<input type="button" class="button" value="'.$ax["iex_download_file"].'" onClick="location.href=\'dloader.php?file=luxcal.ics\'" />'."\n";
}
echo "</form>\n";
echo "</div>\n";
echo '<div style="clear:right"></div>'."\n";
}

function makeFile() {
	global $ax, $calendarTitle, $calendarUrl, $fileDes, $catName, $fromDda, $fromMda, $tillDda, $tillMda;

	$icsHead = "BEGIN:VCALENDAR\r\n";
	$icsHead .= "METHOD:PUBLISH\r\n";
	$icsHead .= "PRODID:-//LuxCal ".constant('LCV')."//".$calendarTitle."//EN\r\n";
	$icsHead .= "VERSION:2.0\r\n";
	$icsHead .= "X-LC-CONTENT:cat: ".(($catName != '*') ? $catName : "all");
	$icsHead .= " // due: ".(($fromDda) ? $fromDda : "begin")." - ".(($tillDda) ? $tillDda : "end");
	$icsHead .= " // mod: ".(($fromMda) ? $fromMda : "begin")." - ".(($tillMda) ? $tillMda : "end")."\r\n";
	$icsHead .= "X-WR-CALNAME:".(($fileDes) ? $fileDes : "Events")."\r\n";
	$icsHead .= "X-WR-TIMEZONE:".date_default_timezone_get()."\r\n";
	$icsHead .= "CALSCALE:GREGORIAN\r\n";

	//set filter
	$filter = ($catName != '*') ? " AND c.name = '$catName'" : "";
	if ($fromDda) { $filter .= " AND ((d.r_type = 0 AND (IF(d.e_date != '9999-00-00', d.e_date, d.s_date) >= '$fromDda')) OR (d.r_type > 0 AND d.r_until >= '$fromDda'))"; }
	if ($tillDda) { $filter .= " AND d.s_date <= '$tillDda'"; }
	if ($fromMda) { $filter .= " AND d.m_date >= '$fromMda'"; }
	if ($tillMda) { $filter .= " AND d.m_date <= '$tillMda'"; }
	
	$q =
	"SELECT
		DATE_FORMAT(d.s_date,'%Y%m%d'), #0
		DATE_FORMAT(d.e_date,'%Y%m%d'), #1
		DATE_FORMAT(d.s_time,'%H%i%s'), #2
		DATE_FORMAT(d.e_time,'%H%i%s'), #3
		d.a_date, #4
		d.m_date, #5
		d.r_type, #6
		d.r_interval, #7
		d.r_period, #8
		DATE_FORMAT(d.r_until,'%Y%m%d'), #9
		d.notify, #10
		e.title, #11
		e.venue, #12
		e.user_id, #13
		e.description, #14
		e.private, #15
		c.name #16
	FROM [db]events e
		INNER JOIN [db]dates d ON d.event_id = e.event_id
		INNER JOIN [db]categories c ON c.category_id = e.category_id
	WHERE
		d.status >= 0
		".$filter."
	ORDER BY
		d.s_date";
	$result = dbquery($q);
	if (mysql_num_rows($result) == 0) { return $ax["iex_no_events_found"]; }
	$icsBody = "";
	while ($row = mysql_fetch_array($result)) {
		if (!$row['private'] or ($row['user_id'] == $_SESSION['uid']) or $sedit) { // private: only for current user + admin
			$vDescription = trim(chunk_split($row['description'],72, "\r\n ")); //fold to 72 chars line length
			//compile DTSTART and DTEND values
			$dtEnd = ($row[1][0] != '9') ? $row[1] : $row[0];
			$dtStart = $row[0];
			if ($row[2] == '000000' and $row[3] == '235900') { //all day
				$allDay = true;
				$dtEnd = date('Ymd', mktime (0, 0, 0, substr($dtEnd,4,2), substr($dtEnd,6,2)+1, substr($dtEnd,0,4))); //+1 day
			} else {
				$allDay = false;
				$dtStart .= "T".$row[2];
				$dtEnd .= "T".(($row[3][0] != '9') ? $row[3] : substr($row[2],0,5).'1');
			}
			
			//compile RRULE property
			$rrule = "";
			if ($row['r_type'] == 1) { //every 1|2|3|4 d|w|m|y
				$rrule .= "FREQ=";
				switch ($row['r_period']) {
					case 1: $rrule .= 'DAILY'; break;
					case 2: $rrule .= 'WEEKLY'; break;
					case 3: $rrule .= 'MONTHLY'; break;
					case 4: $rrule .= 'YEARLY';
				}
				$rrule .= ";INTERVAL=".$row['r_interval'];
			}
			if ($row['r_type'] == 2) { //every 1|2|3|4|5 m|t|w|t|f|s|s of the month
				$rrule .= "FREQ=MONTHLY;BYDAY=".(($row['r_interval'] != 5) ? $row['r_interval'] : '-1');
				switch ($row['r_period']) {
					case 1: $rrule .= 'MO'; break;
					case 2: $rrule .= 'TU'; break;
					case 3: $rrule .= 'WE'; break;
					case 4: $rrule .= 'TH'; break;
					case 5: $rrule .= 'FR'; break;
					case 6: $rrule .= 'SA'; break;
					case 7: $rrule .= 'SU'; break;
				}
			}
			if ($row[9][0] != '9') {
				$rrule .= ";UNTIL=".$row[9];
			}
			$tStamp = mktime (substr($row[2],0,2), substr($row[2],2,2), 0, substr($row[0],4,2), substr($row[0],6,2), substr($row[0],0,4));
			$icsBody .= "BEGIN:VEVENT\r\n";
			$icsBody .= "DTSTAMP:".gmdate('Ymd\THis\Z')."\r\n";
			$icsBody .= "CREATED:".gmdate('Ymd\THis\Z', mktime (0, 0, 0, substr($row[4],5,2), substr($row[4],8,2)+1, substr($row[4],0,4)))."\r\n";
			$icsBody .= "LAST-MODIFIED:".gmdate('Ymd\THis\Z', mktime (0, 0, 0, substr($row[5],5,2), substr($row[5],8,2)+1, substr($row[5],0,4)))."\r\n";
			$icsBody .= "UID:".gmdate("Ymd\THis\Z", $tStamp).trim(substr($row[11],0,4))."-LuxCal@".$calendarUrl."\r\n";
			$icsBody .= "SUMMARY:".$row['title']."\r\n";
			if ($row['description']) { $icsBody .= "DESCRIPTION;ENCODING=QUOTED-PRINTABLE:".$vDescription."\r\n"; }
			$icsBody .= "CATEGORIES:".$row['name']."\r\n";
			if ($row['venue']) { $icsBody .= "LOCATION:".$row['venue']."\r\n"; }
			if ($rrule) { $icsBody .= "RRULE:".$rrule."\r\n"; }
			$icsBody .= "DTSTART;VALUE=".($allDay ? "DATE" : "DATE-TIME").":".$dtStart."\r\n";
			$icsBody .= "DTEND;VALUE=".($allDay ? "DATE" : "DATE-TIME").":".$dtEnd."\r\n"; // +1 ?
			$icsBody .= "END:VEVENT\r\n";
		}
	}
	$icsTail = "END:VCALENDAR";
	//save to iCal file
	file_put_contents("files/luxcal.ics", $icsHead.$icsBody.$icsTail, LOCK_EX);
	return $ax["iex_file_created"];
}


// control logic

$msg = ""; //init
if ($sedit) {
	echo ($msg) ? "<p class=\"warningL\">".$msg."</p>\n" : "<p class=\"noWarningL\">&nbsp;</p>\n";
	while (true) {
		if (isset($_POST["create"])) {
			$msg = makeFile();
			selectEvents(); //error - again
			break;
		}
		if (!isset($_POST["create"])) {
			selectEvents();
			break;
		}
	}
} else {
	echo "<p class=\"warningL\">You are not authorized to perform this action</p>\n";
}
?>
