<?php
/*
= Change Calendar Settings page =

 Copyright 2010 LuxSoft - Luxembourg - www.LuxSoft.eu

This file is part of the LuxCal Web Calendar.

The LuxCal Web Calendar is free software: you can redistribute it and/or modify it under 
the terms of the GNU General Public License as published by the Free Software Foundation, 
either version 3 of the License, or (at your option) any later version.

The LuxCal Web Calendar is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with the LuxCal 
Web Calendar. If not, see <http://www.gnu.org/licenses/>.
*/

$adminLang = (file_exists('lang/ai-'.strtolower($_SESSION['cL']).'.php')) ? $_SESSION['cL'] : "English";
require 'lang/ai-'.strtolower($adminLang).'.php';

$msg = "";

if (!$sedit) {
	echo "<p class=\"warningL\">You are not authorized to perform this action</p>\n"; exit;
}

if (isset($_REQUEST["save"])) { //get posted settings
	$newCalendarTitle = stripslashes(trim($_POST["newCalendarTitle"]));
	$newCalendarUrl = trim($_POST["newCalendarUrl"]);
	$newCalendarEmail = stripslashes(trim($_POST["newCalendarEmail"]));
	$newTimeZone = trim($_POST["newTimeZone"]);
	$newDefaultView = intval($_POST["newDefaultView"]);
	$newLanguage = trim($_POST["newLanguage"]);
	$newLangMenu = intval($_POST["newLangMenu"]);
	$newChgEmailList = trim($_POST["newChgEmailList"]);
	$newChgNofDays = intval($_POST["newChgNofDays"]);
	$newSelfReg = intval($_POST["newSelfReg"]);
	$newSelfRegPrivs = intval($_POST["newSelfRegPrivs"]);
	$newMaxNoLogin = intval($_POST["newMaxNoLogin"]);
	$newColsToShow = intval($_POST["newColsToShow"]);
	$newRowsToShow = intval($_POST["newRowsToShow"]);
	$newWeeksToShow = intval($_POST["newWeeksToShow"]);
	$newUpcomingDays = intval($_POST["newUpcomingDays"]);
	$newStartHour = intval($_POST["newStartHour"]);
	$newShowOwner = intval($_POST["newShowOwner"]);
	$newDateFormat = intval($_POST["newDateFormat"]);
	$newDateUSorEU = intval($_POST["newDateUSorEU"]);
	$newDateSep = trim($_POST["newDateSep"]);
	$newTime24 = intval($_POST["newTime24"]);
	$newWeekStart = intval($_POST["newWeekStart"]);
} else { // get current settings
	$newCalendarTitle = $calendarTitle;
	$newCalendarUrl = $calendarUrl;
	$newCalendarEmail = $calendarEmail;
	$newTimeZone = $timeZone;
	$newDefaultView = $defaultView;
	$newLanguage = $language;
	$newLangMenu = $langMenu;
	$newChgEmailList = $chgEmailList;
	$newChgNofDays = $chgNofDays;
	$newSelfReg = $selfReg;
	$newSelfRegPrivs = $selfRegPrivs;
	$newMaxNoLogin = $maxNoLogin;
	$newColsToShow = $colsToShow;
	$newRowsToShow = $rowsToShow;
	$newWeeksToShow = $weeksToShow;
	$newUpcomingDays = $upcomingDays;
	$newStartHour = $startHour;
	$newShowOwner = $showOwner;
	$newDateFormat = $dateFormat;
	$newDateUSorEU = $dateUSorEU;
	$newDateSep = $dateSep;
	$newTime24 = $time24;
	$newWeekStart = $weekStart;
}

if (isset($_REQUEST["save"])) { // validate settings
	if (!$newCalendarTitle) { $msg .= $ax["calendarTitle_label"].' '.$ax["set_missing"].'<br />'; }
	if (!$newCalendarUrl) { $msg .= $ax["calendarUrl_label"].' '.$ax["set_missing"].'<br />'; }
	if (!$newCalendarEmail) { $msg .= $ax["calendarEmail_label"].' '.$ax["set_missing"].'<br />'; }
	if (!$newTimeZone) { $msg .= $ax["timeZone_label"].' '.$ax["set_missing"].'<br />'; }
	if ($newChgNofDays < 0 or $newChgNofDays > 30) { $msg .= $ax["chgNofDays_label"].' '.$ax["set_not_valid"].'<br />'; }
	if ($newMaxNoLogin < 0 or $newMaxNoLogin > 365) { $msg .= $ax["maxNoLogin_label"].' '.$ax["set_not_valid"].'<br />'; }
	if ($newColsToShow < 1 or $newColsToShow > 6) { $msg .= $ax["colsToShow_label"].' '.$ax["set_not_valid"].'<br />'; }
	if ($newRowsToShow < 1 or $newRowsToShow > 10) { $msg .= $ax["rowsToShow_label"].' '.$ax["set_not_valid"].'<br />'; }
	if ($newWeeksToShow != 0 and ($newWeeksToShow < 2 or $newWeeksToShow > 20)) { $msg .= $ax["weeksToShow_label"].' '.$ax["set_not_valid"].'<br />'; }
	if ($newUpcomingDays < 1 or $newUpcomingDays > 365) { $msg .= $ax["upcomingDays_label"].' '.$ax["set_not_valid"].'<br />'; }
	if ($newStartHour < 0 or $newStartHour > 18) { $msg .= $ax["startHour_label"].' '.$ax["set_not_valid"].'<br />'; }

	if (!$msg) { // no errors save settings;
	while (true) {
		$config = file_get_contents("config.php");
		if ($config === false) { $msg = $ax["set_read_error"]; break; }
		$pos = stripos($config, '$calendarTitle');
		$config = substr($config,0,$pos).
		'$calendarTitle = "'.$newCalendarTitle.'"; //Calendar title displayed in the top bar'."\n\n".
		'$calendarUrl = "'.$newCalendarUrl.'"; //Calendar location (URL)'."\n\n".
		'$calendarEmail = "'.$newCalendarEmail.'"; //Sender in email notifications'."\n\n".
		'$timeZone = "'.$newTimeZone.'"; //Calendar time zone'."\n\n".
		'$defaultView = '.$newDefaultView.'; //Calendar view at start-up (1: year, 2: month, 3: week 4: day, 5: upcoming, 6: changes)'."\n\n".
		'$language = "'.$newLanguage.'"; //User interface language'."\n\n".
		'$langMenu = '.$newLangMenu.'; //Display ui-language selection menu'."\n\n".
		'$chgEmailList = "'.$newChgEmailList.'"; //Destin. email addresses for calendar changes'."\n\n".
		'$chgNofDays = '.$newChgNofDays.'; //Number of days to look back for calendar changes'."\n\n".
		'$selfReg = '.$newSelfReg.'; //Self-registration (1: enabled 0: disabled)'."\n\n".
		'$selfRegPrivs = '.$newSelfRegPrivs.'; //Self-reg rights (1: view, 2: post own, 3: post all)'."\n\n".
		'$maxNoLogin = '.$newMaxNoLogin.'; //Number of days not logged in, before deleting user account (0: never delete)'."\n\n".
		'$colsToShow = '.$newColsToShow.'; //Number of months to show per row in year view'."\n\n".
		'$rowsToShow = '.$newRowsToShow.'; //Number of rows to show in year view'."\n\n".
		'$weeksToShow = '.$newWeeksToShow.'; //Number of weeks to show in month view'."\n\n".
		'$upcomingDays = '.$newUpcomingDays.'; //Number of days to look ahead in upcoming view'."\n\n".
		'$startHour = '.$newStartHour.'; //Day/week view start hour'."\n\n".
		'$showOwner = '.$newShowOwner.'; //Show event owner (0: no, 1: yes)'."\n\n".
		'$dateFormat = '.$newDateFormat.'; //Event date format (1: dd-mm-yyyy, 2: mm-dd-yyyy, 3: yyyy-mm-dd)'."\n\n".
		'$dateUSorEU = '.$newDateUSorEU.'; //Calendar date format (0: Monday, May 12, 2010, 1: Monday 12 May 2010)'."\n\n".
		'$dateSep = "'.$newDateSep.'"; //Date separator (. - or /)'."\n\n".
		'$time24 = '.$newTime24.'; //Time format (0: 12-hour am/pm, 1: 24-hour)'."\n\n".
		'$weekStart = '.$newWeekStart.'; // Week starts on Sunday(0) or Monday(1)'."\n".
		"?>\n";
		$result = file_put_contents("config.php", $config); //save updated config.php file
		if ($result === false) { $msg = $ax["set_write error"]; break; }
		$msg = $ax["set_settings_saved"];
		break;
		}
	}
}

echo "<br /><p class=\"warningL\">".(($msg) ? $msg : $ax["hover_for_details"])."</p>\n";
echo '<div class="container spaceLL">'."\n";
?>
<form action="index.php" method="post">
<table>
<tr><td><table class="fieldBoxFix">
<?php
echo '<tr><td class="legend" colspan="2">&nbsp;'.$ax["set_cal_settings"].'&nbsp;</td><tr>'."\n";
echo "<tr><td class=\"labelFix\" onmouseover=\"popon('".$ax["calendarTitle_text"]."', 'lightyellow')\" onmouseout=\"popoff()\">".$ax["calendarTitle_label"].":</td>\n";
echo '<td><input type="text" name="newCalendarTitle" size="45" value="'.$newCalendarTitle.'" /></td></tr>'."\n";

echo "<tr><td class=\"labelFix\" onmouseover=\"popon('".$ax["calendarUrl_text"]."', 'lightyellow')\" onmouseout=\"popoff()\">".$ax["calendarUrl_label"].":</td>\n";
echo '<td><input type="text" name="newCalendarUrl" size="45" value="'.$newCalendarUrl.'" /></td></tr>'."\n";

echo "<tr><td class=\"labelFix\" onmouseover=\"popon('".$ax["calendarEmail_text"]."', 'lightyellow')\" onmouseout=\"popoff()\">".$ax["calendarEmail_label"].":</td>\n";
echo '<td><input type="text" name="newCalendarEmail" size="45" value="'.$newCalendarEmail.'" /></td></tr>'."\n";

echo "<tr><td class=\"labelFix\" onmouseover=\"popon('".$ax["timeZone_text"]."', 'lightyellow')\" onmouseout=\"popoff()\">".$ax["timeZone_label"].":</td>\n";
echo '<td><input type="text" name="newTimeZone" size="24" value="'.$newTimeZone.'" /> '.$ax["see"].': <strong>[<a href="http://us3.php.net/manual/en/timezones.php" target="_blank">'.$ax["time_zones"].'</a>]</strong></td></tr>'."\n";

echo "<tr><td class=\"labelFix\" onmouseover=\"popon('".$ax["defaultView_text"]."', 'lightyellow')\" onmouseout=\"popoff()\">".$ax["defaultView_label"].":</td>\n";
echo '<td><select class="input" name="newDefaultView">'."\n";
echo '<option value="1"'.($newDefaultView == "1" ? ' selected="selected"' : '').'>'.$xx["hdr_year"]."</option>\n";
echo '<option value="2"'.($newDefaultView == "2" ? ' selected="selected"' : '').'>'.$xx["hdr_month"]."</option>\n";
echo '<option value="3"'.($newDefaultView == "3" ? ' selected="selected"' : '').'>'.$xx["hdr_week"]."</option>\n";
echo '<option value="4"'.($newDefaultView == "4" ? ' selected="selected"' : '').'>'.$xx["hdr_day"]."</option>\n";
echo '<option value="5"'.($newDefaultView == "5" ? ' selected="selected"' : '').'>'.$xx["hdr_upcoming"]."</option>\n";
echo '<option value="6"'.($newDefaultView == "6" ? ' selected="selected"' : '').'>'.$xx["hdr_changes"]."</option>\n";
echo "</select></td></tr>\n";

echo "<tr><td class=\"labelFix\" onmouseover=\"popon('".$ax["language_text"]."', 'lightyellow')\" onmouseout=\"popoff()\">".$ax["language_label"].":</td>\n";
echo '<td><select class="input" name="newLanguage">'."\n";
	$files = scandir("lang/");
	foreach ($files as $file) {
		if (substr($file, 0, 3) == "ui-") {
			$lang = strtolower(substr($file,3,-4));
			echo '<option value="'.$lang.'"'.(strtolower($newLanguage) == $lang ? ' selected="selected"' : '').'>'.ucfirst($lang)."</option>\n";
		}
	}
echo "</select></td></tr>\n";

echo "<tr><td class=\"labelFix\" onmouseover=\"popon('".$ax["langMenu_text"]."', 'lightyellow')\" onmouseout=\"popoff()\">".$ax["langMenu_label"].":</td>\n";
echo '<td><input type="radio" name="newLangMenu" value="0"'.($newLangMenu == 0 ? 'checked="checked"' : '').' /> '.$ax["disabled"]."&nbsp;&nbsp;&nbsp;\n";
echo '<input type="radio" name="newLangMenu" value="1"'.($newLangMenu == 1 ? 'checked="checked"' : '').' /> '.$ax["enabled"].'</td></tr>'."\n";

echo "<tr><td class=\"labelFix\" onmouseover=\"popon('".$ax["chgEmailList_text"]."', 'lightyellow')\" onmouseout=\"popoff()\">".$ax["chgEmailList_label"].":</td>\n";
echo '<td><input type="text" name="newChgEmailList" size="45" value="'.$newChgEmailList.'" /></td></tr>'."\n";

echo "<tr><td class=\"labelFix\" onmouseover=\"popon('".$ax["chgNofDays_text"]."', 'lightyellow')\" onmouseout=\"popoff()\">".$ax["chgNofDays_label"].":</td>\n";
echo '<td><input type="text" name="newChgNofDays" size="1" value="'.$newChgNofDays.'" /> (0 - 30)</td></tr>'."\n";
?>
</table></td></tr>
<tr><td><table class="fieldBoxFix">
<?php
echo '<tr><td class="legend" colspan="2">&nbsp;'.$ax["set_user_settings"].'&nbsp;</td><tr>'."\n";
echo "<tr><td class=\"labelFix\" onmouseover=\"popon('".$ax["selfReg_text"]."', 'lightyellow')\" onmouseout=\"popoff()\">".$ax["selfReg_label"].":</td>\n";
echo '<td><input type="radio" name="newSelfReg" value="0"'.($newSelfReg == 0 ? 'checked="checked"' : '').' /> '.$ax["disabled"]."&nbsp;&nbsp;&nbsp;\n";
echo '<input type="radio" name="newSelfReg" value="1"'.($newSelfReg == 1 ? 'checked="checked"' : '').' /> '.$ax["enabled"].'</td></tr>'."\n";

echo "<tr><td class=\"labelFix\" onmouseover=\"popon('".$ax["selfRegPrivs_text"]."', 'lightyellow')\" onmouseout=\"popoff()\">".$ax["selfRegPrivs_label"].":</td>\n";
echo '<td><input type="radio" name="newSelfRegPrivs" value="1"'.($newSelfRegPrivs == 1 ? 'checked="checked"' : '').' /> '.$ax["view"]."&nbsp;&nbsp;&nbsp;\n";
echo '<input type="radio" name="newSelfRegPrivs" value="2"'.($newSelfRegPrivs == 2 ? 'checked="checked"' : '').' /> '.$ax["post_own"]."&nbsp;&nbsp;&nbsp;\n";
echo '<input type="radio" name="newSelfRegPrivs" value="3"'.($newSelfRegPrivs == 3 ? 'checked="checked"' : '').' /> '.$ax["post_all"]."</td></tr>\n";

echo "<tr><td class=\"labelFix\" onmouseover=\"popon('".$ax["maxNoLogin_text"]."', 'lightyellow')\" onmouseout=\"popoff()\">".$ax["maxNoLogin_label"].":</td>\n";
echo '<td><input type="text" name="newMaxNoLogin" size="1" value="'.$newMaxNoLogin.'" /> (0 - 365)</td></tr>'."\n";
?>
</table></td></tr>
<tr><td><table class="fieldBoxFix">
<?php
echo '<tr><td class="legend" colspan="2">&nbsp;'.$ax["set_view_settings"].'&nbsp;</td><tr>'."\n";
echo "<tr><td class=\"labelFix\" onmouseover=\"popon('".$ax["colsToShow_text"]."', 'lightyellow')\" onmouseout=\"popoff()\">".$ax["colsToShow_label"].":</td>\n";
echo '<td><input type="text" name="newColsToShow" size="1" value="'.$newColsToShow.'" /> (1 - 6)</td></tr>'."\n";

echo "<tr><td class=\"labelFix\" onmouseover=\"popon('".$ax["rowsToShow_text"]."', 'lightyellow')\" onmouseout=\"popoff()\">".$ax["rowsToShow_label"].":</td>\n";
echo '<td><input type="text" name="newRowsToShow" size="1" value="'.$newRowsToShow.'" /> (1 - 10)</td></tr>'."\n";

echo "<tr><td class=\"labelFix\" onmouseover=\"popon('".$ax["weeksToShow_text"]."', 'lightyellow')\" onmouseout=\"popoff()\">".$ax["weeksToShow_label"].":</td>\n";
echo '<td><input type="text" name="newWeeksToShow" size="1" value="'.$newWeeksToShow.'" /> (2 - 20 or 0)</td></tr>'."\n";

echo "<tr><td class=\"labelFix\" onmouseover=\"popon('".$ax["upcomingDays_text"]."', 'lightyellow')\" onmouseout=\"popoff()\">".$ax["upcomingDays_label"].":</td>\n";
echo '<td><input type="text" name="newUpcomingDays" size="1" value="'.$newUpcomingDays.'" /> (1 - 365)</td></tr>'."\n";

echo "<tr><td class=\"labelFix\" onmouseover=\"popon('".$ax["startHour_text"]."', 'lightyellow')\" onmouseout=\"popoff()\">".$ax["startHour_label"].":</td>\n";
echo '<td><input type="text" name="newStartHour" size="1" value="'.$newStartHour.'" /> (0 - 18)</td></tr>'."\n";

echo "<tr><td class=\"labelFix\" onmouseover=\"popon('".$ax["showOwner_text"]."', 'lightyellow')\" onmouseout=\"popoff()\">".$ax["showOwner_label"].":</td>\n";
echo '<td><input type="radio" name="newShowOwner" value="0"'.($newShowOwner == 0 ? 'checked="checked"' : '').' /> '.$ax["no"]."&nbsp;&nbsp;&nbsp;\n";
echo '<input type="radio" name="newShowOwner" value="1"'.($newShowOwner == 1 ? 'checked="checked"' : '').' /> '.$ax["yes"].'</td></tr>'."\n";
?>
</table></td></tr>
<tr><td><table class="fieldBoxFix">
<?php
echo '<tr><td class="legend" colspan="2">&nbsp;'.$ax["set_dt_settings"].'&nbsp;</td><tr>'."\n";
echo "<tr><td class=\"labelFix\" onmouseover=\"popon('".$ax["dateFormat_text"]."', 'lightyellow')\" onmouseout=\"popoff()\">".$ax["dateFormat_label"].":</td>\n";
echo '<td><input type="radio" name="newDateFormat" value="1"'.($newDateFormat == 1 ? 'checked="checked"' : '').' /> '.$ax["dd_mm_yyyy"]."&nbsp;&nbsp;&nbsp;\n";
echo '<input type="radio" name="newDateFormat" value="2"'.($newDateFormat == 2 ? 'checked="checked"' : '').' /> '.$ax["mm_dd_yyyy"]."&nbsp;&nbsp;&nbsp;\n";
echo '<input type="radio" name="newDateFormat" value="3"'.($newDateFormat == 3 ? 'checked="checked"' : '').' /> '.$ax["yyyy_mm_dd"].'</td></tr>'."\n";

echo "<tr><td class=\"labelFix\" onmouseover=\"popon('".$ax["dateUSorEU_text"]."', 'lightyellow')\" onmouseout=\"popoff()\">".$ax["dateUSorEU_label"].":</td>\n";
echo '<td><input type="radio" name="newDateUSorEU" value="0"'.($newDateUSorEU == 0 ? 'checked="checked"' : '').' /> '.$ax["date_format_us"]."&nbsp;&nbsp;&nbsp;\n";
echo '<input type="radio" name="newDateUSorEU" value="1"'.($newDateUSorEU == 1 ? 'checked="checked"' : '').' /> '.$ax["date_format_eu"].'</td></tr>'."\n";

echo "<tr><td class=\"labelFix\" onmouseover=\"popon('".$ax["dateSep_text"]."', 'lightyellow')\" onmouseout=\"popoff()\">".$ax["dateSep_label"].":</td>\n";
echo '<td><input type="radio" name="newDateSep" value="."'.($newDateSep == "." ? 'checked="checked"' : '').' /> '.$ax["dot"].' ( . )'."&nbsp;&nbsp;&nbsp;\n";
echo '<input type="radio" name="newDateSep" value="/"'.($newDateSep == "/" ? 'checked="checked"' : '').' /> '.$ax["slash"].' ( / )'."&nbsp;&nbsp;&nbsp;\n";
echo '<input type="radio" name="newDateSep" value="-"'.($newDateSep == "-" ? 'checked="checked"' : '').' /> '.$ax["hyphen"].' ( - )</td></tr>'."\n";

echo "<tr><td class=\"labelFix\" onmouseover=\"popon('".$ax["time24_text"]."', 'lightyellow')\" onmouseout=\"popoff()\">".$ax["time24_label"].":</td>\n";
echo '<td><input type="radio" name="newTime24" value="0"'.($newTime24 == 0 ? 'checked="checked"' : '').' /> '.$ax["time_format_us"]."&nbsp;&nbsp;&nbsp;\n";
echo '<input type="radio" name="newTime24" value="1"'.($newTime24 == 1 ? 'checked="checked"' : '').' /> '.$ax["time_format_eu"].'</td></tr>'."\n";

echo "<tr><td class=\"labelFix\" onmouseover=\"popon('".$ax["weekStart_text"]."', 'lightyellow')\" onmouseout=\"popoff()\">".$ax["weekStart_label"].":</td>\n";
echo '<td><input type="radio" name="newWeekStart" value="0"'.($newWeekStart == 0 ? 'checked="checked"' : '').' /> '.$ax["sunday"]."&nbsp;&nbsp;&nbsp;\n";
echo '<input type="radio" name="newWeekStart" value="1"'.($newWeekStart == 1 ? 'checked="checked"' : '').' /> '.$ax["monday"].'</td></tr>'."\n";
?>
</table></td></tr>
</table>
<br />
<input class="button" type="submit" name="save" value="<?php echo $ax["set_save_settings"]; ?>" />
</form>
</div>
