<?php
/*
= view calendar changes (added / edited / deleted events) since specified date =


 Copyright 2010 LuxSoft - Luxembourg - www.LuxSoft.eu

This file is part of the LuxCal Web Calendar.

The LuxCal Web Calendar is free software: you can redistribute it and/or modify it under 
the terms of the GNU General Public License as published by the Free Software Foundation, 
either version 3 of the License, or (at your option) any later version.

The LuxCal Web Calendar is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with the LuxCal 
Web Calendar. If not, see <http://www.gnu.org/licenses/>.
*/

function sortEvt($a, $b) { return strcmp(strval($a['sts']+1).$a['sda'].$a['sti'], strval($b['sts']+1).$b['sda'].$b['sti']); }

function showGrid($date) {
	global $evtList, $privs, $wkDays, $showOwner, $xx;
	if ($evtList[$date]) {
		usort($evtList[$date], 'sortEvt');
		echo "<br /><h5>".$xx['chg_changed_on']." ".makeD($date,6,false)."</h5><br />\n";
		foreach ($evtList[$date] as $evt) {
			switch ($evt["r_t"]) { //make repeat text
				case 0: $repeat = ""; break;
				case 1: $repeat = $xx['evt_repeat'].' '.$xx['evt_interval1_'.$evt['r_i']].' '.$xx['evt_period1_'.$evt['r_p']]; break;
				case 2: $repeat = $xx['evt_repeat_on'].' '.$xx['evt_interval2_'.$evt['r_i']].' '.$wkDays[$evt['r_p']].' '.$xx['evt_of_the_month'];
			}
			if ($evt['r_t'] > 0 and $evt['r_u']) {
				$repeat .= ' '.$xx['evt_until'].' '.IDtoDD($evt['r_u']);
			}
			
			$access = ($privs > 2 or $evt['uid'] == $_SESSION['uid']) ? true : false;
			if ($access) { // has access
				echo "<table><tr class=\"point\" onclick=\"x=eventWin('index.php?xP=11&amp;id=".$evt['eid']."'); x.focus(); return false\">";
			} else {
				echo "<table><tr class=\"arrow\">";
			}
			echo "<td class=\"vaTop\" width=\"100px\">";
			echo ($evt['sts'] < 0) ? $xx['chg_deleted'] : ($evt['mda'] > $evt['ada'] ? $xx['chg_edited'] : $xx['chg_added']);
			echo "</td><td>";
			echo IDtoDD($evt['sda']);
			if ($evt['sti']) echo " @ ".ITtoDT($evt['sti']);
			if ($evt['eda'] or $evt['eti']) echo " -";
			if ($evt['eda']) echo " ".IDtoDD($evt['eda']);
			if ($evt['eda'] and $evt['eti']) echo " @";
			if ($evt['eti']) echo " ".ITtoDT($evt['eti']);
			echo ($evt['sti'] == "" and $evt['eti'] == "") ? " ".$xx["vws_all_day"] : "";
			if ($repeat) { echo ". ".$repeat; }
			echo "<h5><span".(($evt['col'] or $evt['bco']) ? " style=\"color: ".$evt['col']."; background: ".$evt['bco'].";\">\n" : ">\n").$evt['tit']."</span></h5>\n";
			if ($evt['ven']) { echo $xx['vws_venue'].": ".$evt['ven']."<br />\n"; }
			if ($evt['des']) { echo $evt['des']."<br />\n"; }
			if ($evt['not'] > 0 and $access) { echo "# ".$xx['chg_notify'].": ".$evt['not']." ".$xx['chg_days']." #<br />\n"; }
			if ($showOwner) { echo $xx["vws_owner"].": ".$evt['una']."<br />\n"; }
			echo "</td></tr></table><br />\n";
		}
	}
}

function grabChanges($sDate) { //query db for changes since $sDate
	global $evtList, $sedit;
	$catFilter = ($_SESSION['cC'] > 0) ? "AND e.category_id = ".$_SESSION['cC'] : '';
	$q =
	"SELECT
		d.s_date, #0
		d.e_date, #1
		DATE_FORMAT(d.s_time,'%H:%i'), #2
		DATE_FORMAT(d.e_time,'%H:%i'), #3
		d.r_type, #4
		d.r_interval, #5
		d.r_period, #6
		d.r_until, #7
		d.notify, #8
		d.a_date, #9
		d.m_date, #10
		d.status, #11
		e.event_id, #12
		e.title, #13
		e.category_id, #14
		e.venue, #15
		e.user_id, #16
		e.description, #17
		e.private, #18
		c.sequence, #19
		c.color, #20
		c.background, #21
		u.user_name #22
	FROM [db]events e
		INNER JOIN [db]dates d ON d.event_id = e.event_id
		INNER JOIN [db]categories c ON c.category_id = e.category_id
		INNER JOIN [db]users u ON u.user_id = e.user_id
	WHERE
		d.m_date != '9999-00-00' AND d.m_date >= '$sDate'
		".$catFilter;
	$query = dbquery($q);

	//process events
	while ($row = mysql_fetch_row($query)) {
		if (!$row[18] or ($row[18] == $_SESSION['uid']) or $sedit) { // private: only for current user + admin
			$event['sda'] = $row[0];
			$event['eda'] = ($row[1][0] != '9') ? $row[1] : "";
			if (($row[2] == "00:00") and ($row[3] == "23:59")) {
				$event['sti'] = $event['eti'] = ""; //all day: start/end time = ""
			} else {
				$event['sti'] = $row[2];
				$event['eti'] = ($row[3][0] != '9') ? $row[3] : ""; // no end time = ""
			}
			$event['r_t'] = $row[4];
			$event['r_i'] = $row[5];
			$event['r_p'] = $row[6];
			$event['r_u'] = ($row[7][0] != '9') ? $row[7] : "";
			$event['not'] = $row[8];
			$event['ada'] = ($row[9][0] != '9') ? $row[9] : "";
			$event['mda'] = $row[10];
			$event['sts'] = $row[11];
			$event['eid'] = $row[12];
			$event['tit'] = stripslashes($row[13]);
			$event['cat'] = $row[14];
			$event['ven'] = stripslashes($row[15]);
			$event['uid'] = $row[16];
			$event['des'] = stripslashes($row[17]);
			$event['pri'] = $row[18];
			$event['seq'] = str_pad($row[19],2,"0",STR_PAD_LEFT);
			$event['col'] = $row[20];
			$event['bco'] = $row[21];
			$event['una'] = $row[22];
			$evtList[$event['mda']][] = $event;
		}
	}
}


// main program

$evtList = array();
$fromD = (isset($_REQUEST["fromD"])) ? DDtoID($_REQUEST["fromD"]) : date('Y-m-d');
$fromD = min($fromD, date('Y-m-d'));

grabChanges($fromD); // query db for changes

echo "<div class=\"container\">";

echo "<form method=\"post\" id=\"selectD\" name=\"selectD\" action=\"index.php\">\n";
echo $xx["chg_from_date"].': ';
echo '<input class="input" type="text" name="fromD" id="fromD" value="'.IDtoDD($fromD)."\" size='10' />\n";
echo '<input class="button" type="button" title="'.$xx['chg_select_date']."\" value=\"...\" onclick=\"dPicker('selectD','fromD')\" />\n";
echo "</form>\n";
echo "<br />\n";

echo "<div class=\"eventBg\">\n";
echo '<input class="button floatR" name="noprint" type="button" onclick="printUpc(\'dummy\')" value="'.$xx["vws_print"].'" />';
if ($fromD != date('Y-m-d')) {
	echo '<h4>',makeD($fromD,2,false)," - ",makeD(date('Y-m-d'),2,false),'</h4>'."\n<br />\n";
}
if ($evtList) {
	ksort($evtList);
	while (list($k) = each($evtList)) {
		showGrid($k);
	}
} else {
	echo "<br />".$xx['chg_no_changes']."<br />";
}
echo "</div><br />";
echo "</div>";
?>
