<?php
/*
 = General functions used by Week and Day view modules =


 Copyright 2010 LuxSoft - Luxembourg - www.LuxSoft.eu

This file is part of the LuxCal Web Calendar.

The LuxCal Web Calendar is free software: you can redistribute it and/or modify it under 
the terms of the GNU General Public License as published by the Free Software Foundation, 
either version 3 of the License, or (at your option) any later version.

The LuxCal Web Calendar is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with the LuxCal 
Web Calendar. If not, see <http://www.gnu.org/licenses/>.
*/

function showGrid($date) {
	global $privs, $evtList, $startHour, $showOwner, $xx;
	$start_H = $startHour ? $startHour : 0;
	$start_M = $startHour ? 0 : 30;
	$thM = ($start_H * 60) + $start_M; //threshold in minutes
	if (!array_key_exists($date, $evtList)) { return; }
	//hereafter: M = in nbr of mins, HM = in hh:mm
	foreach ($evtList[$date] as $eIx => $evt) {
		if (($evt['sti'] == "") and ($evt['eti'] == "")) { //all day
			$st[] = 0;  //start time
			$et[] = 30; //end time
		} else {
			$stM = substr($evt['sti'],0,2) * 60 + intval(substr($evt['sti'],3,2)); //start time
			$etM = substr($evt['eti'],0,2) * 60 + intval(substr($evt['eti'],3,2)); //end time
			$st[] = ($stM < $thM) ? 0 : $stM - $thM + 30; //start time < threshold in mins
			$et[] = ($etM <= $thM) ? 30 : $etM - $thM + 30; //end time < threshold in mins
		}
		$evIx[] = $eIx; //event index in $evtList[$date]
	}
	$sEmpty[0][0] = 0;
	$eEmpty[0][0] = 1440; // 24 x 60
	$indent = 0;
	foreach ($st as $i => $stM) { //i: index stM: start time in mins
		$found = false;
		foreach ($sEmpty as $k => $v) {
			foreach ($sEmpty[$k] as $kk => $sE) {
				if (($stM >= $sE) && ($et[$i] <= $eEmpty[$k][$kk])) {
					$sEmpty[$k][] = $et[$i]; // end in mins
					$eEmpty[$k][] = $eEmpty[$k][$kk];
					$eEmpty[$k][$kk] = $stM; // start in mins
					$sFill[$k][] = $stM;
					$eIndx[$k][] = $evIx[$i];
					$found = true;
					break 2;
				}
			}
		}
		if (!$found) {
			$indent++;
			$sEmpty[$indent][0] = 0;
			$sEmpty[$indent][1] = $et[$i];
			$eEmpty[$indent][0] = $stM;
			$eEmpty[$indent][1] = 1440; // 24 x 60
			$sFill[$indent][0] = $stM;
			$eIndx[$indent][0] = $evIx[$i];
		}
	}
	$wide = round(100 / ($indent+1));
	$width = $wide - 2;
	foreach ($sFill as $k => $v) { //note: 1 min = 1px
		$left = $wide * $k;
		foreach ($sFill[$k] as $kk => $stM) { //stM: start time in mins
			$eHeight = $sEmpty[$k][$kk + 1] - $stM -2; //height in mins - 2
			$stM += 17; //skip cellTop
			$i = $eIndx[$k][$kk];
			$evt = &$evtList[$date][$i];
			$access = ($privs > 2 or $evt['uid'] == $_SESSION['uid']) ? true : false;
			$time = ($evt['sti']) ? ITtoDT($evt['sti']) : "";
			$popText = "<b>".$time;
			if ($evt['eti']) { $popText .= " - ".ITtoDT($evt['eti']); }
			$popText .= "&nbsp;&nbsp;&nbsp;".$evt['tit']."</b>";
			if ($evt['ven']) { $popText .= "<br />".$evt['ven']; }
			if ($evt['des']) { $popText .= "<br />".$evt['des']; }
			if ($evt['not'] > 0 and $access) { $popText .= "<br />".$xx['pop_notify'].": ".$evt['not']." ".$xx['pop_days']; }
			if ($showOwner) { $popText .= "<br />".$xx['pop_owner'].": ".$evt['una']; }
			$popText = htmlspecialchars(addslashes($popText));
			echo $access ? "\n<div class=\"date point\"" : "\n<div class=\"date arrow\"";
			echo " style=\"top:".$stM."px; left:".$left."%; height:".$eHeight."px; width:".$width."%;";
			echo ($evt['col']) ? " color:".$evt['col'].";" : "";
			echo ($evt['bco']) ? " background:".$evt['bco'].";\"" : "background:#FFFFFF;\"";
			if ($access) { echo " onclick=\"x=eventWin('index.php?xP=11&amp;id=".$evt['eid']."'); x.focus(); return false\""; }
			echo " onmouseover=\"popon('".$popText."', 'lightyellow')\" onmouseout=\"popoff()\">\n";
			echo "<div class=\"inner\"";
			if ($evt['col']) echo " style=\"color:".$evt['col']."; background:".$evt['bco'].";";
			echo "\">".$evt['tit']."</div>\n</div>\n";
		}
	}
}

function showHours() {
	global $startHour, $xx;
	// build day
	echo "<div class=\"timeFrame\">\n";
	echo "<div class=\"cellTop\">".$xx["vws_time"]."</div>\n";
	echo "<div class=\"timeCell\">".$xx["vws_all_day"]."</div>\n";
	$i = $startHour ? $startHour : 0;
	$j = $startHour ? "00" : "30";
	while ($i < 24) {
		echo "<div class=\"timeCell\">".ITtoDWT(str_pad($i,2,"0",STR_PAD_LEFT).":".$j)."</div>\n";
		$j = ($j == "00") ? "30" : "00";
		if ($j == "00") {
			$i++;
		}
	}
	echo "</div>\n";
}

function showDay($sDate,$caption="") {
	global $startHour, $xx;

	// build day
	echo "<div class=\"timeFrame\">\n";
	if($caption) {
		echo "<div class=\"cellTop\">".$caption."</div>\n";
	} else {
		echo '<a href="index.php?cP=4&amp;cD='.$sDate.'" title="'.$xx["vws_view_day"].'"><div class="cellTop">'.makeD($sDate,5,false)."</div></a>\n";
	}
	echo "<span class=\"cell\" id=\"t00:00:".$sDate."\"></span>\n";
	$i = $startHour ? $startHour : 0;
	$j = $startHour ? "00" : "30";
	while ($i < 24) {
		echo "<span class=\"cell\" id=\"t".str_pad($i,2,"0",STR_PAD_LEFT).":".$j.":".$sDate."\"></span>\n";
		$j = ($j == "00") ? "30" : "00";
		if ($j == "00") { $i++; }
	}
	echo "<div class=\"dates\">\n";
	showGrid($sDate);
	echo "</div>";
	echo "</div>\n";
}


if ($privs > 1) {
?>
<script type="text/javascript">
// drag time functions
var start, end, color;

window.onload = function() {
	var x = new Array();
	x = document.getElementsByTagName("span");
	color = x[0].style.backgroundColor;
	for (var i = (x.length - 1);i >= 0;i--) {
		x[i].onmousedown = starttime;
		x[i].onmouseover = dragtime;
		x[i].onmouseup = endtime;
	}
}

function starttime() {
	start = end = this.id;
	this.style.backgroundColor = "#cccccc";
}

function dragtime() {
	if (start) {
		if (this.id < end) {
			document.getElementById(end).style.backgroundColor=color;
		} else {
			this.style.backgroundColor = "#cccccc";
		}
		end = this.id;
	}
}

function endtime() {
	var i,j,win,sdate,stime,etime;
	var x = new Array;
	if (end >= start) {
		i = start.substr(1,2);
		j = start.substr(4,2);
		sdate = start.substr(7);
		stime = i + ":" + j;
		i = parseInt(end.substr(1,2),10);
		j = end.substr(4,2);
		j = (j == "00") ? "30" : "00";
		if (j == "00") { i++; }
		if (i == 24) { i--; j = "59"; }
		etime = String("0" + i).slice(-2) + ":" + j;
		win = eventWin('index.php?xP=10&evDate=' + sdate + '&evTimeS=' + stime + '&evTimeE=' + etime);
		win.focus();
		x = document.getElementsByTagName("span");
		for (var i = (x.length - 1);i >= 0;i--) {
			x[i].style.backgroundColor = color;
		}
	}
	start = end = null;
}
</script>
<?php
}
?>
