<?php
/*
= year view of events =
Config Params:
- $colsToShow (number of months to show in one row)
- $rowsToShow (Number of rows of $colsToShow months)


 Copyright 2010 LuxSoft - Luxembourg - www.LuxSoft.eu

This file is part of the LuxCal Web Calendar.

The LuxCal Web Calendar is free software: you can redistribute it and/or modify it under 
the terms of the GNU General Public License as published by the Free Software Foundation, 
either version 3 of the License, or (at your option) any later version.

The LuxCal Web Calendar is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with the LuxCal 
Web Calendar. If not, see <http://www.gnu.org/licenses/>.
*/

function sortEvt($a, $b) { return strcmp($a['sti'].$a['seq'], $b['sti'].$b['seq']); }

function showGrid($date) {
	global $evtList, $privs, $showOwner, $xx;
	if (!array_key_exists($date, $evtList)) { return; }
	usort($evtList[$date], 'sortEvt');
	foreach ($evtList[$date] as $evt) {
		$access = ($privs > 2 or $evt['uid'] == $_SESSION['uid']) ? true : false;
		if ($evt['sti']) { $evt['sti'] = ITtoDT($evt['sti']); }
		$popText = "<b>".$evt['sti'].($evt['eti'] ? " - ".ITtoDT($evt['eti'])." " : " ").$evt['tit']."</b>";
		if ($evt['ven']) { $popText .= "<br />".$evt['ven']; }
		if ($evt['des']) { $popText .= "<br />".$evt['des']; }
		if ($evt['not'] > 0 and $access) { $popText .= "<br />".$xx['pop_notify'].": ".$evt['not']." ".$xx['pop_days']; }
		if ($showOwner) { $popText .= "<br />".$xx['pop_owner'].": ".$evt['una']; }
		$popText = htmlspecialchars(addslashes($popText));
		echo $access ? "\n<div class=\"square point\"" : "\n<div class=\"square arrow\"";
		if ($evt['bco']) { echo " style=\"background:".$evt['bco'].";\""; }
		if ($access) { echo " onclick=\"x=eventWin('index.php?xP=11&amp;id=".$evt['eid']."'); x.focus(); return false\""; }
		echo " onmouseover=\"popon('".$popText."', 'lightyellow')\" onmouseout=\"popoff()\">&nbsp;</div>\n";
	}
}

$evtList = array();
require 'views/retrieve.php';

$cD = $_SESSION['cD'];
$m = substr($cD, 5, 2);
$y = substr($cD, 0, 4);
$jumpRows = $rowsToShow - intval($rowsToShow*0.5);
$prevDate = date( "Y-m-d", mktime( 0, 0, 0, $m-$colsToShow*$jumpRows, 1, $y ) );
$nextDate = date( "Y-m-d", mktime( 0, 0, 0, $m+$colsToShow*$jumpRows, 1, $y ) );

/* determine the start date and end date of the period to show */
$fromM = $m - ($m-1)%$colsToShow; // start month
$tillM = $fromM + $colsToShow * $rowsToShow; // month following end month
$sDate = date("Y-m-d", mktime( 0, 0, 0, $fromM, 1, $y )); // start date
$eDate = date("Y-m-d", mktime( 0, 0, 0, $tillM, 0, $y )); // end date

retrieve($sDate,$eDate); // retrieve events

$header = makeD($sDate,3,false)." - ".makeD($eDate,3,false);
echo '<h3 class="floatC"><a href="index.php?cD=',$prevDate,'"><img src="images/arrowl.gif" alt="back" /></a>&nbsp;&nbsp;&nbsp;',$header,'&nbsp;&nbsp;&nbsp;<a href="index.php?cD=',$nextDate,'"><img src="images/arrowr.gif" alt="forward" /></a></h3>';
echo '<table class="mgrid" width="100%">';
$cm = $fromM; // current month
for($p=0;$p<$rowsToShow;$p++){ // number of rows (of 4 months each) to show
	echo '<tr>';
	for($q=0;$q<$colsToShow;$q++){ // # of months per row
		echo '<td class="holder">';

		/* collect month info */
		$timeDay1 = mktime( 0, 0, 0, $cm, 1, $y ); // Unix time of month
		$day1 = date( "Y-m-d", $timeDay1 );
		$thisM = substr($day1,5,2);
		$thisY = substr($day1,0,4);
		$sOffset = ($weekStart) ? date("N", $timeDay1) - 1 : date("w", $timeDay1); // offset first day
		$eOffset = date( "t", $timeDay1 ) + $sOffset; // offset last day
		$daysToShow = ($eOffset == 28) ? 28 : (($eOffset > 35) ? 42 : 35);  // 4, 5 or 6 weeks

		/* prepare month table */
		echo '<h5 class="floatC"><a href="index.php?cP=2&amp;cD=',$day1,'" title="'.$xx["vws_view_month"].'">',makeD($day1,3,false),"</a></h5>\n";
		echo '<table class="grid">'; 
		echo '<tr><th>'.$xx["vws_wk"].'</th>';
		for ($x = $weekStart; $x < ($weekStart+7); $x++) echo '<th class="dcoly">', $wkDays_s[$x], '</th>';
		echo "</tr>\n";

		/* start building the month */
		for ( $i = 0; $i < $daysToShow; $i++ ) {
			$curTime = mktime( 0, 0, 0, $thisM, $i-$sOffset +1, $thisY );
			$curDate = date("Y-m-d", $curTime);
			if ($i%7 == 0) { // display week nr
				echo '<tr class="yearWeek"><td class="wnr textS"><a href="index.php?cP=3&amp;cD=',$curDate,'" title="'.$xx["vws_view_week"].'">'.date("W", $curTime + 86400)."</a></td>\n";
			}
			$dow = ($i < $sOffset or $i >= $eOffset) ? 'class="out' : ((date("N", $curTime) > 5) ? 'class="we0' : 'class="wd0');
			$dow .= ($curDate == date("Y-m-d")) ? ' today"' : '"';
			$day = ltrim(substr($curDate, 8, 2),"0");
			$dayLink = ($privs > 1) ? "<a onclick=\"x=eventWin('index.php?xP=10&amp;evDate=".$curDate."'); x.focus()\" title=\"".$xx["vws_add_event"]."\">".$day."</a>" : $day;
			echo "<td ".$dow."><div class=\"dom\">".$dayLink."</div>";
			if ($dow != 'class="out"') { showGrid($curDate); }
			echo "</td>\n";

			/* if last day of week, wrap to other side */
			if ( $i%7 == 6) { echo "</tr>\n"; }
		}
		echo "</table>\n";
		echo "</td>\n";
		$cm++;
	}
	echo "</tr>\n";
}
echo "</table>\n";
echo '<h3 class="floatC"><a href="index.php?cD=',$prevDate,'"><img src="images/arrowl.gif" alt="back" /></a><span class="spacer"></span><a href="index.php?cD=',$nextDate,'"><img src="images/arrowr.gif" alt="forward" /></a></h3>';
?>
